#ifndef SENTENCE_H_
#define SENTENCE_H_

#include <iostream>
#include <string>
#include "./Phrase.h"

using namespace std;

class Sentence: public Phrase {
  public:
    Sentence(const string& phrase = "") : Phrase(phrase) {}
    virtual ~Sentence(){}

    const Phrase getSubstring(const unsigned start, const unsigned end) const{
      Phrase substring;
      if(language == SRC)
        return Phrase( WordIDArray(&wordIDArray[start], &wordIDArray[end+1]) );
      else // language == TGT
        return Phrase( WordIDArray(&wordIDArray[start], &wordIDArray[end+1]),
                        LMWordIDArray(&lmWordIDArray[start], &lmWordIDArray[end+1]),
                        TGT );
    }

    bool match(const Phrase& phrase, const Range& range) const {
      return match(phrase, range.start);
    }

    bool match(const Phrase& phrase, const unsigned start) const {
      const LMWordIDArray& pLMWordIDArray = phrase.getLMWordIDArray();
      unsigned pos = start;
      for(unsigned i=0; i<pLMWordIDArray.size(); ++i, ++pos)
        if(lmWordIDArray[pos] != pLMWordIDArray[i])
          return false;

      return true;
    }
};

#endif /* SENTENCE_H_ */
