#ifndef TRIANGLETABLE_H_
#define TRIANGLETABLE_H_

#include <vector>
#include "../etc/Typedef.h"

using namespace std;

template <class T> class TriangleTable : public vector< vector<T> >{
 public:
  TriangleTable(const unsigned size = maxSentenceLength)
   : vector< vector<T> >(size)
  {
    for(unsigned i=0; i<size; i++)
      this->at(i).resize(i+1);
  }

  // row:end, col:start
  void set(const unsigned row, const unsigned col, const T& value){
    this->at(row).at(col) = value;
  }
  const T& get(const unsigned row, const unsigned col) const {
    this->at(row).at(col);
  }
  T& get(const unsigned row, const unsigned col) {
    this->at(row).at(col);
  }

  list<T> getColumn(const unsigned column) const {
    list<T> colArray;
    for(unsigned row=0; row<=column; row++)
      colArray.push_back( get(column, row) );
    return colArray;
  }

  list<T> getRow(const unsigned row) const {
    list<T> rowArray;
    for(unsigned column=row; column<this->size(); column++)
      rowArray.push_back( get(column, row) );
    return rowArray;
  }

  void print() const {
    for(unsigned col = 0; col < this->size(); col++)
      for(unsigned row = 0; row < this->at(col).size(); row++)
        cerr << "Lattice [" << col << "][" << row << "]: " << this->at(col).at(row) << endl;
  }

  virtual ~TriangleTable(){}
};

#endif /* TRIANGLETABLE_H_ */
